% iPhoneでの注意など

iPhoneでSafariを使った場合の注意点について書きます。
シュミレータでしか確認していないので、実機とは違う可能性があります。
またiPhone上でChromeを使った場合は、環境がないためテストできてません。


## システム要件

シミュレータ上で確認しました。
実機でどうなるか確認できてません。

iOS11のSafariで動作確認しました。

iOS10ではホーム画面から起動した場合に保存ができませんでした。
ブラウザからだとできますが、やや使いにくいです。


## インストール方法

ブラウザから起動するとアドレスバーとツールバーが常に表示されるため
かなり使いにくいので
以下の作業を行うことをおすすめします。
画面を広く使える上、オフラインで実行できるようになります。

ブラウザでScabarを表示した状態で、
以下のようにボタンを順番に押していきます。

![](image/iphone-1.png)
![](image/iphone-2.png)
![](image/iphone-3.png)

ホーム画面に追加されました。

![](image/iphone-4.png)

ホーム画面から起動したこところです。

![](image/iphone-5.png)



## 画像の保存方法

ブラウザから起動した場合は以下のどちらの方法でも使えますが、
ホーム画面から起動した場合は(2)の方法しか使えません。

### (1) Save Imageボタンから

ScabarのSave Imageボタンを押すと、
新しいタブが作られてそこに画像が表示されます。
画面下にある上矢印のついたボタン(1)を押すと共有とか保存とかできるようです。
たぶんツイッターとかFacebookとかでてくるんじゃないかと思いますが、
実機を持ってないのでわかりません。
終わったら戻るボタン(2)を押してください。

![](image/iphone-6.png)
![](image/iphone-7.png)


### (2) Show Imageボタンから

ScabarのShow Imageボタンを押すと画像が表示されるのでこれを長押ししてください。
そうすると保存するかどうか聞いてくるので、保存してください。

![](image/iphone-8.png)
![](image/iphone-9.png)


## 制限事項

* ブラウザから起動している場合はフルスクリーンにできません。
 -> ホーム画面から起動している場合はフルスクリーンになってます。

* 大きな画像(試したのは7296x5472px 18MB)を
 iPhoneに取り込もうとすると(Scabarは関係なし)
 取り込む時点で画像を自動的に縮小しているようです。
 このときExif情報も消えているので、スケールバーの自動生成はできません。

