/*
   let fontList = Ld.use('fontList').get();
   fontList ->
     [
      "Al Bayan",
       ....
     ]

  Font Name
   [a-z].*   generic name      sans-serif
   [A-Z].*   family name       "Verdana"
*/
(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('fontList',function() {

  const Fl = {};

  Fl.get = get;


  const defaultFonts = [
   "serif",
   "sans-serif",
   "monospace",
  ];


// macだけじゃないぞ
  const macFonts = [

   "cursive",
   "fantasy",

  // Mac
   "Al Bayan", 
   "Al Nile", 
   "Al Tarikh", 
   "American Typewriter", 
   "Andale Mono", 
   "Apple Braille", 
   "Apple Chancery", 
   "Apple Color Emoji", 
   "Apple SD Gothic Neo", 
   "Apple Symbols", 
   "AppleGothic", 
   "AppleMyungjo", 
   "Arial", 
   "Arial Black", 
   "Arial Hebrew", 
   "Arial Hebrew Scholar", 
   "Arial", 
   "Arial Narrow", 
   "Arial Rounded MT Bold", 
   "Arial Unicode MS", 
   "Avenir", 
   "Avenir Next", 
   "Ayuthaya", 
   "Baghdad", 
   "Bangla MN", 
   "Bangla Sangam MN", 
   "Baskerville", 
   "Beirut", 
   "Big Caslon Medium", 
   "Bodoni 72", 
   "Bodoni 72 Oldstyle", 
   "Bodoni 72 Smallcaps", 
    //  "Bodoni Ornaments", 
   "Bradley Hand", 
   "Brush Script MT", 
   "Chalkboard", 
   "Chalkboard SE", 
   "Chalkduster", 
   "Cochin", 
   "Comic Sans MS", 
   "Copperplate", 
   "Corsiva Hebrew", 
   "Courier", 
   "Courier New", 
   "Damascus", 
   "DecoType Naskh", 
   "Devanagari MT", 
   "Devanagari Sangam MN", 
   "Didot", 
   "Diwan Kufi", 
   "Diwan Thuluth", 
   "Euphemia UCAS", 
   "Farah", 
   "Farisi", 
   "Futura", 
   "GB18030 Bitmap", 
   "Geeza Pro", 
   "Geneva", 
   "Georgia", 
   "Gill Sans", 
   "Gujarati MT", 
   "Gujarati Sangam MN", 
   "Gurmukhi MN", 
   "Gurmukhi MT", 
   "Gurmukhi Sangam MN", 
   "Heiti SC", 
   "Heiti TC", 
   "Helvetica", 
   "Helvetica Neue", 
   "Herculanum", 
   "Hiragino Kaku Gothic Pro",
   "Hiragino Kaku Gothic ProN",
   "Hiragino Kaku Gothic Std",
   "Hiragino Kaku Gothic StdN",
   "Hiragino Maru Gothic Pro",
   "Hiragino Maru Gothic ProN",
   "Hiragino Mincho Pro",
   "Hiragino Mincho ProN",
   "Hiragino Sans GB",
   "Hiragino Sans",
   "Hoefler Text", 
   "ITF Devanagari", 
   "ITF Devanagari Marathi", 
   "Impact", 
   "InaiMathi", 
   "Kailasa", 
   "Kannada MN", 
   "Kannada Sangam MN", 
   "Kefa", 
   "Khmer MN", 
   "Khmer Sangam MN", 
   "Kohinoor Bangla", 
   "Kohinoor Devanagari", 
   "Kohinoor Telugu", 
   "Kokonor", 
   "Krungthep", 
   "KufiStandardGK", 
   "Lao MN", 
   "Lao Sangam MN", 
   "Lucida Grande", 
   "Luminari", 
   "Malayalam MN", 
   "Malayalam Sangam MN", 
   "Marker Felt", 
   "Menlo", 
   "Microsoft Sans Serif", 
   "Mishafi Gold", 
   "Mishafi", 
   "Monaco", 
   "Mshtakan", 
   "Muna", 
   "Myanmar MN", 
   "Myanmar Sangam MN", 
   "Nadeem", 
   "New Peninim MT", 
   "Noteworthy", 
   "Optima", 
   "Oriya MN", 
   "Oriya Sangam MN", 
   "PT Mono", 
   "PT Sans", 
   "PT Sans Caption", 
   "PT Sans Narrow", 
   "PT Serif", 
   "PT Serif Caption", 
   "Palatino", 
   "Papyrus", 
   "Phosphate", 
   "PingFang HK", 
   "PingFang SC", 
   "PingFang TC", 
   "Plantagenet Cherokee", 
   "Raanana", 
   /*
     "STIXGeneral-Bold", 
     "STIXGeneral-BoldItalic", 
     "STIXGeneral-Italic", 
     "STIXGeneral-Regular", 
     "STIXIntegralsD-Bold", 
     "STIXIntegralsD-Regular", 
     "STIXIntegralsSm-Bold", 
     "STIXIntegralsSm-Regular", 
     "STIXIntegralsUp-Bold", 
     "STIXIntegralsUp-Regular", 
     "STIXIntegralsUpD-Bold", 
     "STIXIntegralsUpD-Regular", 
     "STIXIntegralsUpSm-Bold", 
     "STIXIntegralsUpSm-Regular", 
     "STIXNonUnicode-Bold", 
     "STIXNonUnicode-BoldItalic", 
     "STIXNonUnicode-Italic", 
     "STIXNonUnicode-Regular", 
     "STIXSizeFiveSym-Regular", 
     "STIXSizeFourSym-Bold", 
     "STIXSizeFourSym-Regular", 
     "STIXSizeOneSym-Bold", 
     "STIXSizeOneSym-Regular", 
     "STIXSizeThreeSym-Bold", 
     "STIXSizeThreeSym-Regular", 
     "STIXSizeTwoSym-Bold", 
     "STIXSizeTwoSym-Regular", 
     "STIXVariants-Bold", 
     "STIXVariants-Regular", 
   */
   "STSong", 
   "Sana Regular", 
   "Sathu", 
   "Savoye LET", 
   "Shree Devanagari 714", 
   "SignPainter-HouseScript", 
   "Silom", 
   "Sinhala MN", 
   "Sinhala Sangam MN", 
   "Skia", 
   "Snell Roundhand", 
   "Songti SC", 
   "Songti TC", 
   "Sukhumvit Set", 
   "Symbol", 
   "Tahoma", 
   "Tamil MN", 
   "Tamil Sangam MN", 
   "Telugu MN", 
   "Telugu Sangam MN", 
   "Thonburi", 
   "Times", 
   "Times New Roman", 
   "Times", 
   "Trattatello", 
   "Trebuchet MS", 
   "Verdana", 
   "Waseem", 
   /*
     "Webdings", 
     "Wingdings", 
     "Wingdings 2", 
     "Wingdings 3", 
   */
   "Zapf Dingbats", 
   "Zapfino", 


  // windows
   "Aharoni",
   "Andalus",
   "Angsana New",
   "AngsanaUPC",
   "Aparajita",
   "Arabic Typesetting",
   "Arial",
   "Arial Unicode MS",
   "Batang",
   "BatangChe",
   "Browallia New",
   "BrowalliaUPC",
   "Calibri",
   "Cambria",
   "Cambria Math",
   "Candara",
   "Comic Sans MS",
   "Consolas",
   "Constantia",
   "Corbel",
   "Cordia New",
   "CordiaUPC",
   "Courier New",
   "DaunPenh",
   "David",
   "DFKai-SB",
   "DilleniaUPC",
   "DokChampa",
   "Dotum",
   "DotumChe",
   "Ebrima",
   "Estrangelo Edessa",
   "EucrosiaUPC",
   "Euphemia",
   "FangSong",
   "Franklin Gothic Medium",
   "FrankRuehl",
   "FreesiaUPC",
   "Gabriola",
   "Gautami",
   "Georgia",
   "Gisha",
   "Gulim",
   "GulimChe",
   "Gungsuh",
   "GungsuhChe",
   "Impact",
   "IrisUPC",
   "Iskoola Pota",
   "JasmineUPC",
   "KaiTi",
   "Kalinga",
   "Kartika",
   "Khmer UI",
   "KodchiangUPC",
   "Kokila",
   "Lao UI",
   "Latha",
   "Leelawadee",
   "Levenim MT",
   "LilyUPC",
   "Lucida Console",
   "Lucida Sans Unicode",
   "Malgun Gothic",
   "Mangal",
   "Meiryo",
   "Meiryo UI",
   "Microsoft Himalaya",
   "Microsoft JhengHei",
   "Microsoft New Tai Lue",
   "Microsoft PhagsPa",
   "Microsoft Sans Serif",
   "Microsoft Tai Le",
   "Microsoft Uighur",
   "Microsoft YaHei",
   "Microsoft Yi Baiti",
   "MingLiU",
   "MingLiU_HKSCS",
   "MingLiU_HKSCS-ExtB",
   "MingLiU-ExtB",
   "Miriam",
   "Miriam Fixed",
   "Mongolian Baiti",
   "MoolBoran",
   "MS Gothic",
   "MS Mincho",
   "MS PGothic",
   "MS PMincho",
   "MS UI Gothic",
   "MV Boli",
   "Narkisim",
   "NSimSun",
   "Nyala",
   "Palatino Linotype",
   "Plantagenet Cherokee",
   "PMingLiU",
   "PMingLiU-ExtB",
   "Raavi",
   "Rod",
   "Sakkal Majalla",
   "Segoe Print",
   "Segoe Script",
   "Segoe UI",
   "Segoe UI Symbol",
   "Shonar Bangla",
   "Shruti",
   "SimHei",
   "Simplified Arabic",
   "Simplified Arabic Fixed",
   "SimSun",
   "SimSun-ExtB",
   "Sylfaen",
   "Symbol",
   "Tahoma",
   "Times New Roman",
   "Traditional Arabic",
   "Trebuchet MS",
   "Tunga",
   "Utsaah",
   "Vani",
   "Verdana",
   "Vijaya",
   "Vrinda",
   /*
    "Webdings",
    "Wingdings",
   */

   // Android 
   "sans-serif-condensed",
   "serif-monospace",
   "casual",
   "sans-serif-smallcaps",

  ];


  function get(){
   let detector = new Detector();
   let fontList = {};
   for( let i = 0; i < defaultFonts.length; i++ ) {
    fontList[defaultFonts[i]] = 1;
   }
   let list = detector.batchDetect(macFonts);
   for( let i = 0; i < list.length; i++ ) {
    fontList[list[i]] = 1;
   }
   return Object.keys(fontList).sort(
    function (a, b) {
     a = a.toLowerCase(); b = b.toLowerCase();
     return a > b? 1 : (a < b? -1 : 0);
    }
   );
  }


  return Fl;
 });
})();
