(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('imageLayer',function(){

 // const Img = {};
  const M    = Ld.ref('main');
  const U    = Ld.use('utility');
  const icon = Ld.use('icon');
  const Mn   = Ld.use('menu');
  const Mp   = Ld.use('mainParam');
  const Cp   = Ld.use('cropParam');
  const Lp   = Ld.use('layerParts');
  const Opt  = Ld.use('option');

  const Img = Lp.derive();


// this...
 // unload
  let originalImage;
  let originalImageURL;
  let originalImageWidth;
  let originalImageHeight;


  //
  let layerEl;
  

  // imageLayerは一つだけで一度しか呼ばれない...
  // check


  const N_CACHE = 4;
  let imageCache = [];


  Img.sig = 'image';


  Img.initialize = function(){
//   let layerEl = document.getElementById(this.id);;
   Img._super.initialize.call(this);
   let layerEl = this.containerEl;
   for( let i = 0; i < N_CACHE; i++ ) {
    let canvas = imageCache[i] = document.createElement('canvas');
    canvas.style.display = "none";
    layerEl.appendChild(canvas);
   }
  };


  Img.onLoadImage = function(img,dataURL){
   originalImage = img;
   for( let i = 0, m = 1; i < N_CACHE; i++, m *= 2 ) {
    let canvas = imageCache[i];
    canvas.width = Math.round(img.width/m);
    canvas.height = Math.round(img.height/m);
    let ctx = canvas.getContext('2d');
    ctx.drawImage( img, 0, 0, canvas.width, canvas.height );
   }
   originalImageURL = dataURL;
   originalImageWidth = img.width;
   originalImageHeight = img.height;
   this.dirty = 1;
  };


  Img.onresize = function(){
   this.dirty = 1;
   M.disp();
  };


  Img.disp = function(param){
   if ( this.dirty ) {
    this.dirty = false;
    for( let i = 0; i < imageCache.length; i++ ){
     imageCache[i].style.display = "none";
    }
    if ( M.imageReady ) {

//     let width = Cp.width/Cp.diagonal*Cp.transform.zoom*M.scale;

     let width = Cp.width/Cp.diagonal*
      Cp.transform.zoom*M.screenScale*Mp.view.scale;

     let canvas;
     let i = imageCache.length-1;
     for( ; i > 0; i-- ) {
      canvas = imageCache[i];
//M.log(i,canvas.width,width);
      if ( canvas.width >= width ) {
//M.log(i,M.scale,Cp.transform.x,Cp.transform.y,Cp.transform.zoom,Cp.transform.rotation);
       break;
      }
     }
     canvas = imageCache[i];
//console.log(Cp.width*M.scale,canvas.width);
     let imageDiagonal = U.dist(canvas.width,canvas.height);

     let scale = 1/imageDiagonal*M.scale*Cp.transform.zoom;
     let scaleX = Cp.mirror? -scale: scale;
     let scaleY = scale;
     let x = (-canvas.width+M.cRect.width)/2 + Cp.transform.x*M.scale;
     let y = (-canvas.height+M.cRect.height)/2 + Cp.transform.y*M.scale;
     let s = `rotate(${Cp.transform.rotation*360}deg)
      scale(${scaleX},${scaleY})`;

     U.setStyle(canvas.style,{
      display:'block', position:'absolute',
      left:x+'px', top:y+'px',
      transformOrigin:'center center', transform:s,
     });
// blockとabsoluteははじめに一度やればいい
    }
   }
  };


  //
/*
  Img.drawCanvas = function(canvas,p){
   let image = originalImage;
//   let cropDiagonal = p.cRect.diagonal;
   let cropDiagonal = U.dist(canvas.width,canvas.height);
   let imageDiagonal = U.dist(image.width,image.height);
   let scale = cropDiagonal/imageDiagonal*Cp.transform.zoom;
   let scaleX = Cp.mirror? -scale: scale;
   let scaleY = scale;
   let ctx = canvas.getContext('2d');
   ctx.save();
   ctx.translate(canvas.width/2,canvas.height/2);
   ctx.translate(Cp.transform.x*cropDiagonal,Cp.transform.y*cropDiagonal);
   ctx.rotate(Cp.transform.rotation*2*Math.PI);
   ctx.scale(scaleX,scaleY);
   ctx.translate(-image.width/2,-image.height/2);
   ctx.drawImage( image, 0, 0, image.width, image.height );
   ctx.restore();
  };
*/

  /*
   save時専用。
  */
  Img.makeSvgText = function(final,p){
   let svg = "";
   let cropDiagonal = p.cRect.diagonal;
   let imageDiagonal = U.dist(originalImageWidth,originalImageHeight);

   let scale = cropDiagonal/imageDiagonal*Cp.transform.zoom;
   let scaleX = Cp.mirror? -scale: scale;
   let scaleY = scale;
   if ( originalImageURL ) {
// console.log("originalImageURL",originalImageURL.length);
    // Safari: color-interpolation-filters="sRGB"を入れないと明るさが変わる
    //   他のブラウザでは変化がないので常にsRGBを設定しておく。
    // Android Chrome: unsharpマスクを掛けると色が変わるorz
    //   ... option?
    let filter = Opt.unsharpMask==='on'? `filter="url(#unsharp)"`: '';

    svg = `<svg viewBox="${-p.cRect.width/2} ${-p.cRect.height/2}
       ${p.cRect.width} ${p.cRect.height}"
      x="${0}" y="${0}"
      style="left:${0}px; top:${0}px;"
      width="${p.cRect.width}" height="${p.cRect.height}"
      xmlns="http://www.w3.org/2000/svg"
      xmlns:xlink="http://www.w3.org/1999/xlink"
     >
      <defs>
       <filter id="unsharp">
        <feConvolveMatrix order="5 5" preserveAlpha="true"
         divisor="-256"
         color-interpolation-filters="sRGB"
         kernelMatrix="1 4 6 4 1 4 16 24 16 4 6 24 -476 24 6 4 16 24 16 4 1 4 6 4 1"
         />
      </filter>
      </defs>
      <g ${filter}>
      <g transform="translate(${Cp.transform.x*cropDiagonal},${Cp.transform.y*cropDiagonal}) rotate(${Cp.transform.rotation*360}) scale(${scaleX},${scaleY})" >
       <image xlink:href="${originalImageURL}"
        x="${-originalImageWidth/2}" y="${-originalImageHeight/2}"
        width="${originalImageWidth}" height="${originalImageHeight}" />
      </g>
      </g>
     </svg>
    `;
/*
 上でやる
      <rect x="${-p.cRect.width/2}" y="${-p.cRect.height/2}"
        width="${p.cRect.width}" height="${p.cRect.height}" fill="white" />
*/
   }
 //console.log("toSvgText",svg);
   return svg;
  };


  return Img;

 });
})();
