(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('messageBox',function(){

  const Mb = {};
  const Gui = Ld.use('gui-object');
  const U = Ld.use('utility');
  const Opt = Ld.use('option');
  const Icon = Ld.use('icon');


  //
  Mb.messageBox = function(arg){
   let mb = Mb.CMessageBox.create(arg);
   mb.open();
    // callback(ok/cancel)
   return mb;
  };


  {
   let C = Mb.CMessageBox = Gui.Object.derive();

   const MIN_FONT_SIZE = 9;
   const TB_HEIGHT = 40;
   const TB_FONT_SIZE = 20;

   C.title = 'Message';

   C.open = function(){

    let obj = this;

    let fs = Math.min(window.innerWidth,720)/36;
    if ( fs < 8 ) { fs = 8; }

    let screenEl = this.screenEl = document.createElement('div');
//
    let opacity = 0.8;
    let bc = Opt.menuBackColor||'0,0,0';
    let c = bc.split(/,/).map(parseFloat);
    // tekitou
    let mono = 0.299*c[0] + 0.587*c[1] + 0.114*c[2];
    let fc = mono >= 128? '0,0,0': '255,255,255';
    let color = `rgba(${fc},0.8)`;
    let bgcolor = `rgba(${bc},${opacity})`;

    U.setStyle(screenEl.style,{
     position:'absolute',
     top:0, bottom:0, left:0, right:0,
     backgroundColor:'rgba(0,0,0,0.4)',
     fontSize:fs+'px',
     lineHeight:(fs*1.6)+'px',
     zIndex:10,
    });
    document.body.appendChild(screenEl);

    let frameEl = this.frameEl = document.createElement('div');
    frameEl.className = 'messageBox';
    U.setStyle(frameEl.style,{
     position:'absolute',
    });
    screenEl.appendChild(frameEl);

    let titleEl = this.titleEl = document.createElement('div');
    U.setStyle(titleEl.style,{
     position:'absolute',
     top:0,left:0,right:TB_HEIGHT+'px',height:TB_HEIGHT+'px',
     fontSize:'1.4em',
     lineHeight:TB_FONT_SIZE+'px',
     backgroundColor:color,
     color:bgcolor,
     boxSizing:'border-box',
     overflow:'hidden',
     padding:`${(TB_HEIGHT-TB_FONT_SIZE)/2}px ${TB_FONT_SIZE/2}px`,
    });
    frameEl.appendChild(titleEl);
    titleEl.innerHTML = this.title;

    let closeEl = document.createElement('div');
    U.setStyle(closeEl.style,{
      position:'absolute',
      top:0, right:0, width:TB_HEIGHT+'px', height:TB_HEIGHT+'px',
      backgroundColor:color,
      color:bgcolor,
      fill:bgcolor,
    });
    this.addHandler(closeEl,'click',function(ev){
     obj.close();
     obj.onclick(ev);
    });
    frameEl.appendChild(closeEl);
    closeEl.innerHTML = Icon.close(TB_HEIGHT+'px');

    let bodyEl = this.bodyEl = document.createElement('div');
    bodyEl.className = 'scrollbox';
    U.setStyle(bodyEl.style,{
     position:'absolute',
     top:TB_HEIGHT+'px', bottom:0, left:0,right:0,
     padding:'1em 2em',
     overflow:'scroll',
     WebkitOverflowScrolling:'touch',
     backgroundColor:bgcolor,
     color:color,
    });
    frameEl.appendChild(bodyEl);
    bodyEl.innerHTML = this.text;

    let div = document.createElement('div');
    U.setStyle(div.style,{
     margin:'2em 1em',
    });
    bodyEl.appendChild(div);

/*
    let buttonEl = document.createElement('div');
    buttonEl.className = 'MBButton';
    U.setStyle(buttonEl.style,{
     display:'inline-block',
     float:'right',
     margin:'auto',
     fontSize:'2em',
     padding:'0.5em 1em',
     border:`solid 2px ${color}`,
     borderRadius:'1em',
     cursor:'default',
    });
    buttonEl.innerHTML = 'OK';
    this.addHandler(buttonEl,'click',function(ev){
     obj.close();
     obj.onclick(ev);
    });
    div.appendChild(buttonEl);
*/

    this.addHandler(window,'resize',function(ev){
     obj.onresize();
    });

    if ( this.buttons ) {
     for( let className in this.buttons ) {
      let handler = this.buttons[className];
      Array.from(screenEl.getElementsByClassName(className))
      .forEach(a=>{
       this.addHandler(a,'click',handler);
      });
     }
    }

    this.onresize();
   };

   C.close = function(){
    if ( this.screenEl ) {
     document.body.removeChild(this.screenEl);
    }
    C._super.close.call(this);
   };

   C.onresize = function(){

    let ww = window.innerWidth;
    let wh = window.innerHeight;
    const maxWidth = 720;
    const maxHeight = 1080;
    let boxw = Math.min(ww,maxWidth);
    let boxh = Math.min(wh,maxHeight);
    let x = (ww-boxw)/2;
    let y = (wh-boxh)/2;
    U.setStyle(this.frameEl.style,{
     left:x+'px', top:y +'px',
     width:boxw+'px', height:boxh+'px',
    });

    let fs = boxw/36;
    if ( fs < MIN_FONT_SIZE ) { fs = MIN_FONT_SIZE; }
    U.setStyle(this.screenEl.style,{
     fontSize:fs+'px',
     lineHeight:(fs*1.6)+'px',
    });

   };

   C.onclick = function(){
   };

  }

  return Mb;

 });

})();
